#! /bin/sh
# Copyright © 2011 Aleksey Cherepanov <aleksey.4erepanov@gmail.com>.  See LICENSE.
# Script to add pattern
# Usage: pattern name wordlist rule1 [rule2 ...]

. ./config.sh

name=$1
wordlist=$2
shift 2

# We save arguments into pattern's file.
echo "$wordlist" > patterns/"$name".wordlist

# Prepare part of config with rules.
rulefile=patterns/"$name".config
echo "[List.Rules:$name]" > "$rulefile"
for rule; do
    echo "$rule" >> "$rulefile"
done

# We compute some statistics.

# We generate resulting wordlist.
conf=$(./prepareconf.sh "$name")
out=patterns/"$name".out
$JOHN -w:"$wordlist" -ru:"$name" -config:"$conf" -stdout > "$out"

# We show amount of words.
total=$(wc -l < "$out")
# John output words count itself.
#echo Words: $total

# We count matches.
# NOTE: Shell was too slow for this.
count=$(python intersection.py "$out" cracked)
echo Matches: $count

mpercent=$(perl -e "print $count * 100 / $total")
echo Percent of matches: $mpercent

# TODO: Overlap
